//
//  ReadWriteController.m
//  AretePop
//
//  Created by Asterisk on 13. 6. 19..
//
//

#import "ReadWriteController.h"
#import "Utility.h"

@interface ReadWriteController ()
{
    int _mode;
    uint32_t _accesspassword;
    uint16_t _startAddress;
    uint16_t _dataLength;
    uint8_t _membank;
    NSData *_data;
}

@end

@implementation ReadWriteController
@synthesize rcp = _rcp;
@synthesize epc = _epc;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view.
    self.olScrollVeiw.scrollEnabled = YES;
    self.olScrollVeiw.contentSize = CGSizeMake(self.view.frame.size.width, self.view.frame.size.height + 300);
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    
    self.rcp.delegate = self;  
    self.olTargetEpc.text = [self.epc bytesToHexString];
}

- (void)tagMemoryReceived:(NSData *)data
{
    dispatch_async(dispatch_get_main_queue(),
    ^{
        if(_mode == 0)
        {
            NSLog(@"%@",[data bytesToHexString]);
            self.olData.text = [data bytesToHexString];
        }
        else if(_mode == 0x20)
        {
            if([data isEqualToData:_data])
            {
                NSString *strErrMsg = [NSString stringWithFormat:@"Write Succeeded"];
                UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Information"
                                                                message:strErrMsg
                                                               delegate:nil
                                                      cancelButtonTitle:@"OK"
                                                      otherButtonTitles:nil];
                
                dispatch_async(dispatch_get_main_queue(),
                               ^{
                                   [alert show];
                               });
            }
            else
            {
                NSString *strErrMsg = [NSString stringWithFormat:@"Write Failed"];
                UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error"
                                                                message:strErrMsg
                                                               delegate:nil
                                                      cancelButtonTitle:@"OK"
                                                      otherButtonTitles:nil];
                
                dispatch_async(dispatch_get_main_queue(),
                               ^{
                                   [alert show];
                               });
            }
            
        }
    });
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (IBAction)eModeChanged:(id)sender
{
    printf("eModeChanged\n");
    
    if(self.olMode.selectedSegmentIndex == 0)
    {
        self.navigationItem.title = @"Read";
    }
    else
    {
        self.navigationItem.title = @"Write";
    }
}

- (IBAction)rightBarButtonItemClicked:(id)sender
{
    [self.olTargetEpc resignFirstResponder];
    [self.olAccessPassword resignFirstResponder];
    [self.olStartAdress resignFirstResponder];
    [self.olLength resignFirstResponder];
    [self.olData resignFirstResponder];
    
    NSString *hexaString = self.olAccessPassword.text;
    NSScanner* pScanner = [NSScanner scannerWithString: hexaString];
    //uint32_t accesspassword;
    [pScanner scanHexInt: &_accesspassword];
    
    //uint16_t startAddress = [self.olStartAdress.text intValue];
    _startAddress = [self.olStartAdress.text intValue];
    //uint16_t dataLength = [self.olLength.text intValue];
    _dataLength = [self.olLength.text intValue];
    //uint8_t membank = self.olTargetMemory.selectedSegmentIndex;
    _membank = self.olTargetMemory.selectedSegmentIndex;
    
    //printf("accesspassword = %08X\n",accesspassword);    
    //NSData *data = [self.olData.text hexStringToBytes];
    _data = [self.olData.text hexStringToBytes];
    
    if(self.epc.length == 0)
        return;
    
    if(self.olMode.selectedSegmentIndex == 0)
    {
        //self.navigationItem.title = @"Read";
        NSLog(@"readFromTagMemory");
        [self.rcp readFromTagMemory:_accesspassword
                                epc:self.epc
                         memoryBank:_membank
                       startAddress:_startAddress
                         dataLength:_dataLength];
        _mode = 0x00;
    }
    else
    {
        //self.navigationItem.title = @"Write";
        NSLog(@"writeToTagMemory");
       [self.rcp writeToTagMemory:_accesspassword
                              epc:self.epc
                       memoryBank:_membank
                     startAddress:_startAddress
                      dataToWrite:_data];
        
        _mode = 0x10;
    }
}

- (void)errDetailReceived:(NSData *)errCode{

    if (errCode.length < 3) return;
    
    Byte *b = (Byte*) [errCode bytes];

    NSString *strErrMsg = [NSString stringWithFormat:@"Error Code: [0x%02X]\nSub Error Code:[0x%02X]", b[0],b[2]];
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error"
                                                    message:strErrMsg
                                                   delegate:nil
                                          cancelButtonTitle:@"OK"
                                          otherButtonTitles:nil];
    
    dispatch_async(dispatch_get_main_queue(),
                   ^{
                       [alert show];
                   });
}

- (void)viewDidUnload {
    [self setOlAccessPassword:nil];
    [self setOlMode:nil];
    [self setOlStartAdress:nil];
    [self setOlLength:nil];
    [self setOlTargetMemory:nil];
    [self setOlData:nil];
    [self setOlTargetEpc:nil];

    [self setOlScrollVeiw:nil];
    [super viewDidUnload];
}

- (void)writedReceived:(uint8_t)statusCode{
//    NSString *responseCode = [NSString stringWithFormat:@"0x%02X",statusCode];
    UIAlertView *alert = [[UIAlertView alloc]initWithTitle:@"Write" message:@"Done." delegate:nil cancelButtonTitle:nil otherButtonTitles:@"OK", nil];
    dispatch_async(dispatch_get_main_queue(), ^{
        [alert show];
    });
}

@end




