//
//  SessionViewController.m
//  AreteCap
//
//  Created by Asterisk on 2015/02/24.
//
//

#import "SessionViewController.h"

@interface SessionViewController ()<UITableViewDelegate,UITableViewDataSource>

@property (weak, nonatomic) IBOutlet UITableView *sessionTableView;
@property (assign, nonatomic) NSInteger selectedIndex;
@property (strong, nonatomic) NSArray *params;
@end

@implementation SessionViewController

- (void)viewDidLoad {
    [super viewDidLoad];

    self.params = @[@"S0",@"S1",@"S2",@"S3"];
    
    _selectedIndex = (int)_session;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return _params.count;
}

- (UITableViewCell*)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    
    static NSString *CellIdentifier = @"Cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier forIndexPath:indexPath];
    
    cell.textLabel.text = _params[indexPath.row];
    if (_selectedIndex == indexPath.row) {
        cell.accessoryType = UITableViewCellAccessoryCheckmark;
    }else{
        cell.accessoryType = UITableViewCellAccessoryNone;
    }
    
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    
    for (int i = 0; i < _params.count; i++) {
        UITableViewCell *cell = [_sessionTableView cellForRowAtIndexPath:[NSIndexPath indexPathForRow:i inSection:0]];
        if (i == indexPath.row) {
            cell.accessoryType = UITableViewCellAccessoryCheckmark;
            _selectedIndex = indexPath.row;

        }else{
            cell.accessoryType = UITableViewCellAccessoryNone;
        }
    }
}

- (IBAction)done:(id)sender {
    
    unsigned int sessionHex = [self hexIntwithString:[NSString stringWithFormat:@"%ld",(long)_selectedIndex]];

    dispatch_async(dispatch_get_main_queue(), ^{
        [self.rcp setSession:sessionHex];
    });
}

- (unsigned int)hexIntwithString:(NSString*)lenStr{
    
    NSScanner*scan = [NSScanner scannerWithString:lenStr];
    unsigned int length;
    [scan scanHexInt:&length];
    return length;
}


@end
