//
//  TagViewController.m
//  AreteEarphoneRfid
//
//  Created by Asterisk on 13. 1. 30..
//
//

#import "TagViewController.h"
#import "CustomCell.h"
#import "TagAccessController.h"
#import "PhyUtility.h"


@interface TagViewController ()
@property (nonatomic, strong, readwrite) TagAccessController *tagAccessController;
@property (nonatomic, strong, readwrite) NSData *epc;
@end

@implementation TagViewController
@synthesize tagAccessController = _tagAccessController;
@synthesize tagIDArray = _tagIDArray;
@synthesize tagCountArray = _tagCountArray;
@synthesize rcp = _rcp;
@synthesize epc = _epc;

- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
    }
    return self;
}



- (NSMutableArray *)tagIDArray
{
    if(!_tagIDArray)
    {
        _tagIDArray = [[NSMutableArray alloc]init];
    }
    
    return _tagIDArray;
}

- (NSMutableArray *)tagCountArray
{
    if(!_tagCountArray)
    {
        _tagCountArray = [[NSMutableArray alloc]init];
    }
    
    return _tagCountArray;
}

- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
    if ([segue.identifier isEqualToString:@"segueTagAccess"])
    {
        [self.rcp stopReadTags];
        self.tagAccessController = segue.destinationViewController;
        self.tagAccessController.rcp = self.rcp;
        self.tagAccessController.epc = self.epc;
    }
}

- (void)viewDidLoad
{
    [super viewDidLoad];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return [self.tagIDArray count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    CustomCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier forIndexPath:indexPath];
    
    // Configure the cell...
    NSData *epc = [self.tagIDArray objectAtIndex:indexPath.row];
    NSMutableString* tag = [[NSMutableString alloc] init];
    unsigned char* ptr= (unsigned char*) [epc bytes];
    for(int i = 0; i < epc.length; i++)
        [tag appendFormat:@"%02X", *ptr++ & 0xFF ];    
    cell.tagID.text = tag;
    NSData *tmp = [epc subdataWithRange:NSMakeRange(2, epc.length - 2)];
    cell.tagHex.text = [tmp bytesToCharString];
    cell.tagCount.text = [NSString stringWithFormat:@"%@"
                          , [self.tagCountArray objectAtIndex:indexPath.row]];
    return cell;
}

#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Navigation logic may go here. Create and push another view controller.
    /*
     <#DetailViewController#> *detailViewController = [[<#DetailViewController#> alloc] initWithNibName:@"<#Nib name#>" bundle:nil];
     // ...
     // Pass the selected object to the new view controller.
     [self.navigationController pushViewController:detailViewController animated:YES];
     */
    NSData *pcEpc = [self.tagIDArray objectAtIndex:indexPath.row];
    self.tagAccessController.epc = [pcEpc subdataWithRange:NSMakeRange(2, pcEpc.length - 2)];
    self.tagAccessController.pcEpc = pcEpc;
    //printf("didSelectRowAtIndexPath\n");
}

- (void)tableView:(UITableView *)tableView willDisplayCell:(UITableViewCell *)cell forRowAtIndexPath:(NSIndexPath *)indexPath
{
    // 偶数セル
    if (indexPath.row % 2 == 0) {
        cell.backgroundColor = [UIColor whiteColor];
    }
    // 奇数セル
    else {
        cell.backgroundColor = [UIColor lightGrayColor];
    }
}

- (void)viewDidUnload {
    [self setTableView:nil];
    [super viewDidUnload];
}
@end
